from pc_ble_driver_py import config
from time import sleep
from threading import Thread

#config.__conn_ic_id__ = 'NRF52'; port = 'COM13'
config.__conn_ic_id__ = 'NRF51'; port = 'COM10'

from pc_ble_driver_py.ble_adapter import *
from pc_ble_driver_py.ble_driver import *

class PasskeyTest(BLEDriverObserver):
    def __init__(self, adapter):
        adapter.driver.observer_register(self)
        self.adapter = adapter
    def on_gap_evt_connected(self, ble_driver, conn_handle, **kwargs):
        print('connected')
        self.conn_handle = conn_handle
        Thread(target=self.adapter.authenticate,
            args=(conn_handle, None),
            kwargs={'bond': True, 'mitm': True, 'io_caps': BLEGapIOCaps.keyboard_only}).start()
    def on_gap_evt_auth_key_request(self, ble_driver, conn_handle, key_type):
        print('passkey request')
        pk = util.list_to_uint8_array(b'123456').cast()
        driver.sd_ble_gap_auth_key_reply(adapter.driver.rpc_adapter, conn_handle, driver.BLE_GAP_AUTH_KEY_TYPE_PASSKEY, pk)
    def on_rpc_log_entry(self, ble_driver, severity, message):
        print(message)


adapter = BLEAdapter(BLEDriver(serial_port=port, log_severity_level='debug'))
observer = PasskeyTest(adapter)
adapter.open()
if config.__conn_ic_id__ == 'NRF51':
    enable_params = BLEEnableParams(
        vs_uuid_count=1,
        service_changed=0,
        periph_conn_count=0,
        central_conn_count=1,
        central_sec_count=1)
else:
    enable_params = None
adapter.driver.ble_enable(enable_params)
addr = BLEGapAddr(BLEGapAddr.Types.random_static, bytes.fromhex('EA97AFB59913'))
adapter.connect(addr)
sleep(2) # to log any events
